package com.io.yutian.elementoriginlib;

import com.io.yutian.elementoriginlib.config.OriginLibConfig;
import com.io.yutian.elementoriginlib.lang.Lang;
import com.io.yutian.elementoriginlib.listener.GuiHandlerListener;
import com.io.yutian.elementoriginlib.listener.PlayerChatInputListener;
import com.io.yutian.elementoriginlib.logger.Logger;
import com.io.yutian.elementoriginlib.manager.CommandManager;
import com.io.yutian.elementoriginlib.redis.RedisIO;
import org.bukkit.plugin.java.JavaPlugin;
import org.slf4j.LoggerFactory;

public final class ElementOriginLib extends JavaPlugin {

    private static final org.slf4j.Logger log = LoggerFactory.getLogger(ElementOriginLib.class);
    private static ElementOriginLib instance;

    private static Logger logger = Logger.getLogger(ElementOriginLib.class);

    private RedisIO redisIO;

    private OriginLibConfig config;

    @Override
    public void onEnable() {
        instance = this;

        new GuiHandlerListener(this);
        new PlayerChatInputListener(this);

        CommandManager.INSTANCE.registerPluginCommand("elementoriginlib");

        reload();

        redisIO = new RedisIO();
        redisIO.init(this);

    }

    @Override
    public void onDisable() {
    }

    public void reload() {
        config = new OriginLibConfig();
        saveDefaultConfig();
        reloadConfig();
        config.load(getConfig());
        Lang.registerLangFile(this);
        Lang.reload();
    }

    public OriginLibConfig getLibConfig() {
        return config;
    }

    public RedisIO getRedisIO() {
        return redisIO;
    }

    public static ElementOriginLib inst() {
        return instance;
    }

}
